// --------------------------------------------------------
// Code generated by Papyrus C++
// --------------------------------------------------------

#define TestTrace_Classes_Package_A1_Package_D1_D1_BODY

/************************************************************
 D1 class body
 ************************************************************/

// include associated header file
#include "TestTrace/Classes/Package_A1/Package_D1/D1.h"

// Derived includes directives
#include "TestTrace/Interfaces/I_MyInterface_1.h"
#include "TestTrace/Interfaces/I_MyInterface_2.h"
#include "TestTrace/Types/MyComplexType_2.h"
#include "barectf/classes/BareCTFInit.h"
#include "ctf/barectf.h"

// Derived using namespaces
using namespace TestTrace::Interfaces;
using namespace TestTrace::Types;
using namespace barectf::classes;
namespace TestTrace {
namespace Classes {
namespace Package_A1 {
namespace Package_D1 {

// static attributes (if any)

/**
 * 
 * @param state 
 */
void D1::MyOperation_1(BooleanType /*in*/state) {
	barectf_default_trace_port_op_starts_D1_listening_MyOperation_1_00001(
			BareCTFInit::ctx(), instanceName);
	std::cout << "Reception of MyOperation_1 in D1" << std::endl;

}

/**
 * 
 * @param param1 
 * @param param2 
 * @param param3 
 * @param param4 
 * @param param5 
 * @param param6 
 */
void D1::MyOperation_2(MyComplexType_1 /*in*/param1,
		MyComplexType_2 /*in*/param2, Integer /*in*/param3, Double /*in*/param4,
		Text /*in*/param5, MyEnumeration /*in*/param6) {
	barectf_default_trace_port_op_starts_D1_listening_MyOperation_2_00002(
			BareCTFInit::ctx(), instanceName);
	std::cout << "Reception of MyOperation_2 in D1" << std::endl;

	setMyDataVar(param1);

}

/**
 * 
 * @param param1 
 */
void D1::setMyDataVar(MyComplexType_1 /*in*/param1) {
	myDataVar = param1;
}

/**
 * 
 * @return ret 
 */
I_MyInterface_1* D1::get_listeningI_MyInterface_1() {
	return this;
}

/**
 * 
 * @return ret 
 */
I_MyInterface_2* D1::get_listeningI_MyInterface_2() {
	return this;
}

} // of namespace Package_D1
} // of namespace Package_A1
} // of namespace Classes
} // of namespace TestTrace

/************************************************************
 End of D1 class body
 ************************************************************/
